﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Luggage : MonoBehaviour
{
    private Player _player;

    [SerializeField] float minSpeed;
    [SerializeField] float maxSpeed;
    [SerializeField] private int _luggageID;

    private float speed;
    private PathFollower _pathToFollow;

    private Vector3 currentPositionHolder; // this holds the node position
    [SerializeField] int currentNode = 0;

    // Start is called before the first frame update
    void Start()
    {
        _player = GameObject.Find("Player").GetComponent<Player>();
        speed = Random.Range(minSpeed, maxSpeed);
        _pathToFollow = GameObject.Find("Path").GetComponent<PathFollower>();
        CheckNode();
    }

    // method to check current Node and move to it, saving the node position to currentPositionHolder variable
    void CheckNode()
    {
        if (currentNode < _pathToFollow.pathNodes.Length)
        {
            currentPositionHolder = _pathToFollow.pathNodes[currentNode].transform.position;
        }
    }

    // Update is called once per frame
    void Update()
    {
        // TODO: here we need to define the luggages path
        //transform.Translate(Vector2.down * speed * Time.deltaTime);

        float step = speed * Time.deltaTime; // calculate distance to move
        if (transform.position != currentPositionHolder)
        {
            // if luggage position is different from the node position, we'll move the luggage to that position
            transform.position = Vector3.MoveTowards(transform.position, currentPositionHolder, step);
        }
        else
        {
            if (currentNode < _pathToFollow.pathNodes.Length)
            {
                // check for future node
                currentNode++;
                CheckNode();
            }
            else if (currentNode == _pathToFollow.pathNodes.Length)
            {
                Destroy(this.gameObject);
                if (_player._myLuggage == _luggageID)
                {
                    _player.LoseLife();
                }
            }
        }
    }

    void OnMouseDown()
    {
        if(_player._myLuggage == _luggageID)
        {
            _player.AddScore(10);
        }
        else
        {
            _player.LoseLife();
        }
        Destroy(this.gameObject);
    }
}
