﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Player : MonoBehaviour
{
    [SerializeField]
    private int _lives = 3;
    [SerializeField]
    private int _score;
    [SerializeField]
    private Spawner _spawner;
    [SerializeField] public int _myLuggage;
    [SerializeField] private Sprite [] _spritesArray;
    private SpriteRenderer spriteRenderer;
    private UIManager _uiManager;


    // Start is called before the first frame update
    void Start()
    {
        _uiManager = GameObject.Find("Canvas").GetComponent<UIManager>();
        _spawner = GameObject.Find("Spawner").GetComponent<Spawner>();
        _myLuggage = Random.Range(0, _spawner.luggageList.Length);
        spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
        spriteRenderer.sprite = _spritesArray[_myLuggage];
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public void LoseLife()
    {
        _lives -= 1;

        _uiManager.UpdateLives(_lives);

        if (_lives < 1)
        {
            _spawner.OnPlayerDeath();
        }
    }

    public void AddScore(int points)
    {
        _score += points;
        ChangeMyLuggage();
        _uiManager.UpdateScore(_score);
    }

    void ChangeMyLuggage()
    {
        _myLuggage = Random.Range(0, _spawner.luggageList.Length);
        spriteRenderer.sprite = _spritesArray[_myLuggage];
    }
}
