﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Spawner : MonoBehaviour
{
    [SerializeField]
    private Vector3 spawnPoint = new Vector3(-1.85f, 10f, 1f); // the spawn point where the luggage should appear

    [SerializeField]
    public GameObject[] luggageList;

    private float timeBetweenSpawns; // this number will increase during the game
    private bool _stopSpawning = false;

    [SerializeField]
    private float startTimeBetweenSpawns; // difficulty of the game at the beginning

    void Start()
    {
        StartCoroutine("SpawnLuggageRoutine");
    }

    // Update is called once per frame
    void Update()
    {
        /*
        if (timeBetweenSpawns <= 0)
        {
            // SPAWN LUGGAGE
            GameObject randomLuggage = luggageList[Random.Range(0, luggageList.Length)];
            Instantiate(randomLuggage, spawnPoint, Quaternion.identity);  // Quaternion.identity means no rotation)
            timeBetweenSpawns = startTimeBetweenSpawns; // setting it back to starting value
        }
        else
        {
            timeBetweenSpawns -= Time.deltaTime;
        }
        */
    }

    IEnumerator SpawnLuggageRoutine()
    {
        while (_stopSpawning == false)
        {
            // SPAWN LUGGAGE
            GameObject randomLuggage = luggageList[Random.Range(0, luggageList.Length)];
            Instantiate(randomLuggage, spawnPoint, Quaternion.identity);  // Quaternion.identity means no rotation)
            yield return new WaitForSeconds(startTimeBetweenSpawns);
        }
    }

    public void OnPlayerDeath()
    {
        _stopSpawning = true;
    }
}