﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class UIManager : MonoBehaviour
{
    [SerializeField]
    private Text _scoreText;


    [SerializeField]
    private Text _livesText;

    [SerializeField]
    private Text _gameOver;
    // [SerializeField] private Text _restartInstructions;
    // [SerializeField] private Image _livesImg;
    //[SerializeField] private Sprite[] _liveSprites;

    private GameManager _gameManager;

    // Start is called before the first frame update
    void Start()
    {
        _gameOver.gameObject.SetActive(false);
        // _restartInstructions.gameObject.SetActive(false);
        _gameManager = GameObject.Find("Game_Manager").GetComponent<GameManager>();

        if (_gameManager == null)
        {
            Debug.Log("GameManager is NULL");
        }
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetMouseButtonDown(0)) {
            _gameManager.StartNewGame();

        }
    }

    public void UpdateScore(int playerScore)
    {
        _scoreText.text = playerScore.ToString();
    }

    public void UpdateLives(int currentLives)
    {
        _livesText.text = currentLives.ToString();
        //_livesImg.sprite = _liveSprites[currentLives];
        if (currentLives <= 0)
        {
            GameOverSequence();
        }
    }

    void GameOverSequence()
    {
        _gameOver.gameObject.SetActive(true);
        // _restartInstructions.gameObject.SetActive(true);
        StartCoroutine("FlickerGameOverRoutine");
        _gameManager.GameOver();
    }
    IEnumerator FlickerGameOverRoutine()
    {
        while (true)
        {
            yield return new WaitForSeconds(0.5f);
            if (_gameOver.gameObject.activeInHierarchy == true)
            {
                _gameOver.gameObject.SetActive(false);
            }
            else
            {
                _gameOver.gameObject.SetActive(true);
            }
        }
    }
}
